/* MAA Message Authenticator Algorithm by D W Davies, NPL 1983.   */
/* Version in C by D O Clayden, NPL 1987.                         */
/* Copyright NPL 1987                                             */
/* Version MAA87C22 suitable for running all tests and timing.    */
/* Most printf statements are for test purposes only.             */

#include <stdio.h>
#include <time.h>
#include <dos.h>
/* Above 3 lines needed only for time measurement. */
/*struct WORDREGS rst;*/  /* for aclock */
/*union twoway {
  unsigned long n;
  struct { unsigned int lint,hint;
    } ti;
  } data;*/

#define BIT31 0x80000000L
#define FFFF  0xFFFFL
unsigned long a,b,c,d,l,m,s,t,u,v,w,x,y,z,pat,sum,t4,t5,v0,x0,y0;

int menu1()
{
  int m,disp;
  printf(" Press a key for menu\n"); disp=getch();
  printf(" 1 Test small functions (Tables 1,2)\n");
  printf(" 2 Test prelude (Table 3)\n");
  printf(" 3 Test main (Table 4)\n");
  printf(" 4 Test prelude + main + coda (Table 5)\n");
  printf(" 5 Test and timing of repeated message blocks (Table 6)\n");
  printf(" 6 Quit to C \n");
  scanf("%d",&m);
  return(m);
} /* menu1 */

void mul32(a,b)
unsigned long a,b;
/* unsigned 64 bit product in u(upper) and l(lower) */
{
  unsigned long p1,p2,p3,sum;
  int car;
  p1=(a&FFFF)*(b&FFFF);
  p2=(a&FFFF)*(b>>16);
  p3=(a>>16)*(b&FFFF);
  sum=(p1>>16)+(p2&FFFF)+(p3&FFFF);
  l=(p1&FFFF)+(sum<<16);
  u=(sum>>16)+(p2>>16)+(p3>>16)+((a>>16)*(b>>16));
} /* mul32 */

unsigned long mul1(a,b)
unsigned long a,b;
{
  unsigned long s,car;
  mul32(a,b);
  s=u+l;
  car=((u^l)&BIT31)? !(s&BIT31):(u&BIT31)!=0;
  return(s+car);
} /* mul1 */

unsigned long mul2(a,b)
unsigned long a,b;
{
  unsigned long d,f,s,car;
  mul32(a,b);
  d=u+u; car=(u&BIT31)!=0;
  f=d+car+car;
  s=f+l;
  car=((f^l)&BIT31)? !(s&BIT31):(f&BIT31)!=0;
  return(s+car+car);
} /* mul2 */

unsigned long mul2a(a,b)
unsigned long a,b;
{
  unsigned long d,s,car;
  mul32(a,b);
  d=u+u;
  s=d+l;
  car=((d^l)&BIT31)? !(s&BIT31):(d&BIT31)!=0;
  return(s+car+car);
} /* mul2a */

void byt(x,y)
unsigned long x,y;
{
  unsigned long p;
  int i,b[8];
  for (i=3; i>=0; i--) {
    b[i]=x&255; b[i+4]=y&255;
    x=x>>8; y=y>>8;
  }
  p=0;
  for (i=0; i<8; i++) {
    p=p+p;
    if (b[i]==0) {p+=1; b[i]=p;} else if (b[i]==255) {p+=1; b[i]=255-p;}
  }
  pat=p; x=0; y=0;
  for (i=0; i<4; i++) {
    x=(x<<8)+b[i]; y=(y<<8)+b[i+4];
  }
  u=x; l=y;
} /* byt */

void prelude(x,y,test)
unsigned long x,y;
int test;
{
  unsigned long j1[10],j2[10],k1[10],k2[10],h[10];
  unsigned long p,q;
  byt(x,y);
  j1[0]=u; k1[0]=l; p=pat;
  printf("P= %lX \n",p);
  if (test>0) {
    j1[0]=x; k1[0]=y;
    printf("Enter P (2 hex): \n");
    scanf("%X",&p);
  }
  q=(p+1)*(p+1);
  j1[2]=mul1(j1[0],j1[0]); j2[2]=mul2(j1[0],j1[0]);
  j1[4]=mul1(j1[2],j1[2]); j2[4]=mul2(j2[2],j2[2]);
  j1[6]=mul1(j1[2],j1[4]); j2[6]=mul2(j2[2],j2[4]);
  j1[8]=mul1(j1[2],j1[6]); j2[8]=mul2(j2[2],j2[6]);
  h[4]=j1[4]^j2[4]; h[6]=j1[6]^j2[6]; h[8]=j1[8]^j2[8];
  printf("H4= %lX \n",h[4]);
  printf("H6= %lX \n",h[6]);
  printf("H8= %lX \n",h[8]);
  k1[2]=mul1(k1[0],k1[0]); k2[2]=mul2(k1[0],k1[0]);
  k1[4]=mul1(k1[2],k1[2]); k2[4]=mul2(k2[2],k2[2]);
  k1[5]=mul1(k1[0],k1[4]); k2[5]=mul2(k1[0],k2[4]);
  k1[7]=mul1(k1[2],k1[5]); k2[7]=mul2(k2[2],k2[5]);
  k1[9]=mul1(k1[2],k1[7]); k2[9]=mul2(k2[2],k2[7]);
  h[0]=k1[5]^k2[5]; h[5]=mul2(h[0],q); h[7]=k1[7]^k2[7]; h[9]=k1[9]^k2[9];
  printf("Hd= %lX \n",h[0]);
  printf("H5= %lX \n",h[5]);
  printf("H7= %lX \n",h[7]);
  printf("H9= %lX \n",h[9]);
  byt(h[4],h[5]);
  x0=u; y0=l;
  printf("X0= %lX",x0);
  printf("  Y0= %lX",y0);
  printf("  PAT= %lX \n",pat);
  byt(h[6],h[7]);
  v0=u; w=l;
  printf("V0= %lX",v0);
  printf("  W= %lX",w);
  printf("  PAT= %lX \n",pat);
  byt(h[8],h[9]);
  s=u; t=l;
  printf("S= %lX",s);
  printf("  T= %lX",t);
  printf("  PAT= %lX \n",pat);
} /* prelude */

void abcd()
{
  a=0x2040801L;
  b=0x804021L;
  c=0xBFEF7FDFL;
  d=0x7DFEFBFFL;
  printf("A= %lX \n",a);
  printf("B= %lX \n",b);
  printf("C= %lX \n",c);
  printf("D= %lX \n",d);
} /* abcd */

void inmain()
{
  abcd();
  printf("Press 1 to enter A,B,C,D,V,W,X0,Y0,M else <RET> for standard ABCD \n");
  if ((getch())=='1') {
    printf("Enter A (8 hex): \n"); scanf("%lX",&a);
    printf("Enter B (8 hex): \n"); scanf("%lX",&b);
    printf("NOT(8)=FFFFFFF7,NOT(4)=FFFFFFFB,NOT(6)=FFFFFFF9,NOT(3)=FFFFFFFC \n");
    printf("NOT(1)=FFFFFFFE,NOT(2*)=7FFFFFFD,NOT(2)=FFFFFFFD \n");
    printf("Enter C (8 hex): \n"); scanf("%lX",&c);
    printf("Enter D (8 hex): \n"); scanf("%lX",&d);
    printf("Enter V (8 hex): \n"); scanf("%lX",&v);
    printf("Enter W (8 hex): \n"); scanf("%lX",&w);
    printf("Enter X0 (8 hex): \n"); scanf("%lX",&x);
    printf("Enter Y0 (8 hex): \n"); scanf("%lX",&y);
    printf("Enter M (8 hex): \n"); scanf("%lX",&m);
  }
} /* inmain */

void mainloop1(m)
unsigned long m;
{
  unsigned long e,f,g;
  printf("Results are in hexadecimal \n");
  v=(v&BIT31)? (v<<1)|1L:v<<1;     /* v=cyc(v); */
		printf("V= %lX \n",v);
  e=v^w;        printf("E= %lX \n",e);
  x=x^m;        printf("X= %lX ",x);
  y=y^m;        printf("  Y= %lX \n",y);
  f=e+y;        printf("F= %lX ",f);
  g=e+x;        printf("  G= %lX \n",g);
  f=f|a;        printf("F= %lX ",f);
  g=g|b;        printf("  G= %lX \n",g);
  f=f&c;        printf("F= %lX ",f);
  g=g&d;        printf("  G= %lX \n",g);
  x=mul1(x,f);  printf("X= %lX ",x);
  y=mul2a(y,g); printf("  Y= %lX \n",y);
} /* mainloop1 */

void mainloop2(m)
unsigned long m;
/* as mainloop1 without printf. Mul1, mul2a copied to save time */
{
  unsigned long e,f,g,s;
  int car;
  v=(v&BIT31)? (v<<1)|1L:v<<1;     /* v=cyc(v); */
  e=v^w;
  x=x^m;        y=y^m;
  f=e+y;        g=e+x;
  f=f|a;        g=g|b;
  f=f&c;        g=g&d;
				   /* x=mul1(x,f); */
  mul32(x,f);
  s=u+l;
  car=((u^l)&BIT31)? !(s&BIT31):(u&BIT31)!=0;
  x=(car) ? s+1L:s;
				   /* y=mul2a(y,g); */
  mul32(y,g);
  g=u+u;
  s=g+l;
  car=((g^l)&BIT31)? !(s&BIT31):(g&BIT31)!=0;
  y=(car)? s+2L:s;
} /* mainloop2 */

/* NOTE. Time measurement is not standard C, hence may not be portable. */
/* Aclock and Guesstime+fracsec are two suggested methods,              */
/* involving MS-DOS, tried with Turbo and Zorland compilers.             */
/* If your clock ticks at 0.1 sec then Guesstime is probably best.      */
/* If your clock ticks at 0.01 sec then Aclock is probably best.        */
/* Use comment marks in main to disable. */

/*long aclock()*/
/* Uses struct WORDREGS which counts fractions of seconds.     */
/* OK for Zorland C version 2, and Turbo C (although warnings) */
/*{
  unsigned tt,ss,mm,hh;
  rst.ax=0x2c00;
  intdos(&rst,&rst);
  tt=rst.dx&0xff;
  ss=rst.dx>>8;
  mm=rst.cx&0xff;
  hh=rst.cx>>8;
  return(tt+100L*(ss+60L*(mm+60L*hh)));
}*/ /* aclock */

unsigned long fracsec()
{
  unsigned long i;
  i=0; t5=time(NULL);
  do i++;              /* count while waiting for next second */
  while (time(NULL)==t5);
  return (i);
} /* fracsec */

float guesstime()
/* Uses fracsec and time (which counts whole seconds).           */
/* Probably most portable, may be least accurate if interrupted. */
/* OK for Turbo and Zorland versions 1 and 2.                    */
{
  unsigned long i,j,secs;
  t4=t5;
  i=fracsec(); secs=t5-t4-1; j=fracsec();
  if (i>j) i=j;
  return (secs+(j-i)/(float)j);
} /* guesstime */

void main()
{
  unsigned long i,t1,t2,prod;
  long ti;
  int nn,ii,choice,disp,car;
  unsigned int x2,y2;
  float tf;
  t5=0;
  do {
    choice=menu1();
    printf("Note all results (except time) are in hexadecimal \n");
    switch(choice) {
      case 1:{
	printf(" Enter X (8 hex): \n"); scanf("%lX",&x);
	printf(" Enter Y (8 hex): \n"); scanf("%lX",&y);
  /*      data.n=x;
	printf("highint= %X",data.ti.hint);
	printf(" lowint= %X\n",data.ti.lint); */
	sum=x+y;
	printf("Sum= %lX",sum);
	car=((x^y)&BIT31) ? !(sum&BIT31):(x&BIT31)!=0;
	printf("  Carry= %X \n",car);
	sum=x+x;
	car=(x&BIT31)!=0;
	printf("2*X= %lX",sum);
	printf("  Carry= %X\n",car);
	printf("Product= %lX\n",x*y);
	x2=x; y2=y; prod=(unsigned long)y2;
	printf("y2long= %lX\n",prod);
	prod=(unsigned long)x2*y2;
	printf("Productx2y2= %lX\n",prod);
	mul32(x,y);
	printf("mul32 upper= %lX",u);
	printf("  mul32 lower= %lX \n",l);
	printf("cyc= %lX\n",((x<<1)|((x&BIT31)>>31)));
	printf("mul1=  %lX\n",mul1(x,y));
	printf("mul2=  %lX\n",mul2(x,y));
	printf("mul2a= %lX\n",mul2a(x,y));
	byt(x,y);
	printf("byt upper= %lX",u);
	printf("  byt lower= %lX\n",l);
	printf("pat= %X\n",pat);
      }; break;
      case 2:{
	printf(" Enter J1 (8 hex): \n"); scanf("%lX",&x);
	printf(" Enter K1 (8 hex): \n"); scanf("%lX",&y);
	prelude(x,y,1);
      }; break;
      case 3:{
	inmain();
	mainloop1(m);
	z=x^y; printf("Z= %lX\n",z);
      }; break;
      case 4:{
	printf(" Enter J (8 hex): \n"); scanf("%lX",&x);
	printf(" Enter K (8 hex): \n"); scanf("%lX",&y);
	prelude(x,y,0);
	x=x0; y=y0; v=v0;
	abcd();
	do {
	  printf(" Enter M (8 hex): \n"); scanf("%lX",&m);
	  mainloop2(m);
	  printf("X= %lX",x); printf("  Y= %lX\n",y);
	  printf("Press 1 for coda else <RET> for another message \n");
	} while ((getch())!='1');
	mainloop2(s);
	printf("X= %lX",x); printf("  Y= %lX\n",y);
	mainloop2(t);
	printf("X= %lX",x); printf("  Y= %lX\n",y);
	z=x^y; printf("Z= %lX\n",z);
      }; break;
      case 5:{
	printf(" Enter J (8 hex): \n"); scanf("%lX",&x);
	printf(" Enter K (8 hex): \n"); scanf("%lX",&y);
	prelude(x,y,0);
	x=x0; y=y0; v=v0;
	abcd();
	printf(" Enter M (8 hex): \n"); scanf("%lX",&m);
	printf(" Enter number of repeated message blocks: \n"); scanf("%d",&nn);
	printf(" Press 1 to display X,Y values for each block else RET to measure time\n");
	disp=getch();
	if (disp=='1') {
	  for (ii=1; ii<=nn; ii++) {
	    mainloop2(m);
	    printf("X= %lX",x); printf("  Y= %lX\n",y);
	  }
	  printf(" Press a key to proceed \n"); disp=getch();
	}
	else {
	  i=fracsec();
/*          ti=aclock(); */
	  for (ii=1; ii<=nn; ii++) {
	    mainloop2(m);
	  }
/*          ti=aclock()-ti; */
	  tf=guesstime();
	  printf("Seconds in mainloop (guesstime)= %6.2f\n",tf); i=i;
	  printf("Millisecs per message block= %6.2f\n",tf*1000.0/nn);
/*          printf("Seconds in mainloop (aclock)= %6.2f\n",ti/100.0);
	  printf("Millisecs per message block= %6.2f\n",ti*10.0/nn);
*/
	}
	printf("X= %lX",x); printf("  Y= %lX\n",y);
	mainloop2(s);
	printf("X= %lX",x); printf("  Y= %lX\n",y);
	mainloop2(t);
	printf("X= %lX",x); printf("  Y= %lX\n",y);
	z=x^y; printf("Z= %lX \n",z);
      }; break;
    }
  } while (choice!=6);
} /* main */