DECLARE FUNCTION FETCH3& (L1$)
REM MESSAGE AUTHENTICATOR ALGORITHM by D W Davies, NPL, 1983
REM MAA95608.BAS for QBASIC June 1995 by D O Clayden, NPL, UK.
DECLARE SUB FETCH (A$, B$, N&)
DECLARE SUB INMAIN ()
DECLARE SUB MAIN1 (M&)
DECLARE FUNCTION MENU1% ()
DECLARE FUNCTION MUL2& (X&, Y&)
DECLARE FUNCTION MUL1& (X&, Y&)
DECLARE FUNCTION MUL2A& (X&, Y&)
DECLARE FUNCTION CYC& (X&)
DECLARE SUB MUL32 (X&, Y&)
DECLARE SUB BYT (X&, Y&)
DECLARE SUB PRELUDE (X&, Y&, TEST&)
DECLARE SUB ABCD ()
DECLARE SUB MAIN2 (M&)
DECLARE FUNCTION MUL16& (X&, Y&)
DECLARE FUNCTION ADDU& (X&, Y&)
DECLARE FUNCTION HVAL& (XX$)
DEFLNG A-Z
DIM SHARED A&, B&, C&, D&, L&, M&, S&, T&, U&, V&, W&, X&, Y&
DIM SHARED G4&, G8&, G3F&, SUM&, CAR&, PAT&, X0&, Y0&, V0&
DIM SHARED ABYT&(8)
OPEN "RESULTS1.TXT" FOR OUTPUT AS #1
10 CLS
20 PRINT "MESSAGE AUTHENTICATOR ALGORITHM by D W Davies NPL, 1983."
21 PRINT "Copyright National Physical Laboratory 1987"
22 PRINT "QBASIC version by D O Clayden, 1995"
30 REM Derived from the BBCBASIC version for 32 bit signed
40 REM arithmetic written in 1987.
60 REM The line numbers of the BBCBASIC program have been retained
61 REM to facilitate comparison of the two versions. The differences
62 REM arise from (a) the use of the SHARED descriptor in place of LOCAL,
63 REM and a bug in QBASIC conversion of hex values in the range &H8000
64 REM to &HFFFF which become negative when assigned to 32 bit variables.
65 REM Several disabled PRINT statements can be enabled for error analysis.
66 REM This version saves results to a file for Tables 5 and 6.
70 :
90 :
100 G4& = &H40000000: G8& = &H80000000: REM global constants
101 G3F& = &H3FFFFFFF
110 :
120 ON MENU1 GOTO 140, 320, 360, 400, 530, 680
130 :
140 CALL FETCH("X", "Y", 8)
150 SUM& = ADDU&(X&, Y&)
160 PRINT "SUM="; HEX$(SUM&)
170 PRINT "CARRY="; CAR&
180 CALL MUL32(X&, Y&)
190 PRINT "MUL32 UPPER="; HEX$(U&); " LOWER="; HEX$(L&)
200 PROD& = MUL1&(X&, Y&)
210 PRINT "MUL1="; HEX$(PROD&)
220 PROD& = MUL2&(X&, Y&)
230 PRINT "MUL2="; HEX$(PROD&)
REM INPUT "PRESS RET", I&
240 PROD& = MUL2A&(X&, Y&)
250 PRINT "MUL2A="; HEX$(PROD&)
REM INPUT "PRESS RET", I&
260 CALL BYT(X&, Y&)
270 PRINT "BYT UPPER="; HEX$(U&); " LOWER="; HEX$(L&); " PAT="; HEX$(PAT&)
280 PROD& = CYC&(X&)
290 PRINT "CYC="; HEX$(PROD&)
300 GOTO 120
310 :
320 CALL FETCH("J", "K", 8)
330 CALL PRELUDE(X&, Y&, 1)
340 GOTO 120
350 :
360 CALL INMAIN
370 CALL MAIN1(M&)
380 GOTO 120
390 :
400 CALL FETCH("J", "K", 8)
410 CALL PRELUDE(X&, Y&, 0)
REM PRINT "S="; HEX$(S&); " T="; HEX$(T&)
420 X& = X0&: Y& = Y0&: V& = V0&
PRINT #1, "X0="; HEX$(X0&); " Y0="; HEX$(Y0&)
PRINT #1, "V0="; HEX$(V&); " W="; HEX$(W&)
430 CALL ABCD
435 DO
440 INPUT "MESSAGE (8HEX)", T$: M& = HVAL(T$)
PRINT #1, "M="; T$
450 CALL MAIN2(M&)
460 INPUT "PRESS 1 RET FOR CODA AND EXIT ELSE RET FOR MORE MESSAGE", I%
470 LOOP UNTIL I% = 1
PRINT "S="; HEX$(S&)
PRINT #1, "S="; HEX$(S&)
480 CALL MAIN2(S&)
PRINT "T="; HEX$(T&)
PRINT #1, "T="; HEX$(T&)
490 CALL MAIN2(T&)
500 Z& = X& XOR Y&: PRINT "Z="; HEX$(Z&)
501 PRINT #1, "Z="; HEX$(Z&)
510 GOTO 120
520 :
530 PRINT "Test case J=80018001,K=80018000 "
531 CALL FETCH("J", "K", 8)
540 CALL PRELUDE(X&, Y&, 0)
550 X& = X0&: Y& = Y0&: V& = V0&
560 CALL ABCD
570 INPUT "MESSAGE (8HEX) (Test case=0)", T$: M& = HVAL(T$)
580 INPUT "Enter number of repeated message blocks (Test case=20)", BLOCKS%
590 FOR NN% = 1 TO BLOCKS%
591 PRINT NN%; " ";
592 PRINT #1, NN%; " ";
600   CALL MAIN2(M&)
610   REM IF NN% MOD 11 = 0 THEN INPUT "Press RET to continue", Z&
620 NEXT
630 CALL MAIN2(S&)
640 CALL MAIN2(T&)
650 Z& = X& XOR Y&: PRINT "Z="; HEX$(Z&); "  (Test case correct Z= DB79FBDC )"
PRINT #1, "Z="; HEX$(Z&)
660 GOTO 120
670 :
680 CLOSE #1
681 END

2450 SUB ABCD
REM SHARED A&, B&, C&, D&
2460 A& = &H2040801
2470 B& = &H804021
2480 C& = &HBFEF7FDF
2490 D& = &H7DFEFBFF
END SUB

700 FUNCTION ADDU& (X&, Y&)
710 REM SHARED G3F&, G4&, G8&, CAR&: REM LOCAL L1&,L2&
720 L1& = (X& AND G3F&) + (Y& AND G3F&)
730 L2& = X& XOR Y&
740 IF (L2& AND G4&) <> 0 THEN CAR& = L1& AND G4&: L1& = (L1& XOR G4&) ELSE CAR& = (X& AND G4&)
750 IF CAR& <> 0 THEN L1& = L1& XOR G8&
760 IF (L2& AND G8&) <> 0 THEN CAR& = L1& AND G8&: L1& = (L1& XOR G8&) ELSE CAR& = (X& AND G8&)
770 IF CAR& <> 0 THEN CAR& = 1
ADDU& = L1&
END FUNCTION

1550 SUB BYT (X&, Y&)
1560 REM SHARED PAT&, U&, L&: REM LOCAL I%,L1&
1561 REM SHARED ABYT&()
PRINT "BYT begin X="; HEX$(X&); " Y="; HEX$(Y&)
1570 FOR I% = 3 TO 0 STEP -1
1580   ABYT&(I%) = X& AND &HFF: ABYT&(I% + 4) = Y& AND &HFF
1590   IF X& >= 0 THEN X& = X& \ &H100 ELSE X& = (X& AND &H7FFFFFFF) \ &H100 + &H800000
1600   IF Y& >= 0 THEN Y& = Y& \ &H100 ELSE Y& = (Y& AND &H7FFFFFFF) \ &H100 + &H800000
1610 NEXT
1620 L1& = 0
1630 FOR I% = 0 TO 7
1640   L1& = L1& * 2
1650   IF ABYT&(I%) = 0 THEN L1& = L1& + 1: ABYT&(I%) = L1& ELSE IF ABYT&(I%) = &HFF THEN L1& = L1& + 1: ABYT&(I%) = &HFF - L1&
1660 NEXT
1670 PAT& = L1&
1680 X& = 0: Y& = 0
1690 FOR I% = 0 TO 3
1700   X& = X& * &H80: X& = ADDU(X&, X&)
1710   Y& = Y& * &H80
1720   Y& = ADDU(Y&, Y&)
1730   X& = X& + ABYT&(I%)
1740   Y& = Y& + ABYT&(I% + 4)
1750 NEXT
1760 U& = X&: L& = Y&
REM PRINT "BYT end: U=X="; HEX$(U&); " L=Y="; HEX$(L&)
END SUB

1520 FUNCTION CYC& (X&)
REM SHARED CAR&: REM LOCAL L1&
L1& = ADDU(X&, X&)
1530 CYC& = L1& + CAR&
END FUNCTION

1250 SUB FETCH (A$, B$, N&)
1260 REM SHARED X&, Y&: REM LOCAL T$
1270 PRINT A$; " ("; N&; "HEX)"; : INPUT T$: X& = HVAL(T$)
1272 PRINT #1, " "; A$; "="; T$;
1280 PRINT B$; " ("; N&; "HEX)"; : INPUT T$: Y& = HVAL(T$)
1282 PRINT #1, " "; B$; "="; T$
END SUB

FUNCTION HVAL& (L1$)
L1& = VAL("&H" + L1$)
IF (LEN(L1$) = 4) AND (L1& < 0) THEN L1& = L1& - &HFFFF0000
HVAL = L1&
END FUNCTION

2320 SUB INMAIN
2330 REM LOCAL T$:REM SHARED A&, B&, C&, D&, V&, W&, X&, Y&, M&
2340 INPUT "A (8HEX)", T$: A& = HVAL(T$)
2350 INPUT "B (8HEX)", T$: B& = HVAL(T$)
2360 INPUT "C (8HEX)", T$: C& = HVAL(T$)
2370 INPUT "D (8HEX)", T$: D& = HVAL(T$)
2380 INPUT "V (8HEX)", T$: V& = HVAL(T$)
2390 INPUT "W (8HEX)", T$: W& = HVAL(T$)
2400 INPUT "X (8HEX)", T$: X& = HVAL(T$)
2410 INPUT "Y (8HEX)", T$: Y& = HVAL(T$)
2420 INPUT "M (8HEX)", T$: M& = HVAL(T$)
END SUB

2520 SUB MAIN1 (M&)
2530 REM SHARED A&, B&, C&, D&, V&, X&, Y&, W&
REM SHARED TIME: REM LOCAL E&,F&,G&,T0
2540 T0 = TIME
REM PRINT "A,B,C,D="; HEX$(A&); ","; HEX$(B&); ","; HEX$(C&); ","; HEX$(D&)
REM PRINT "V,W,X,Y="; HEX$(V&); ","; HEX$(W&); ","; HEX$(X&); ","; HEX$(Y&)
2550 V& = CYC(V&): PRINT "V="; HEX$(V&);
2560 E& = V& XOR W&: PRINT " E="; HEX$(E&)
2570 X& = X& XOR M&: PRINT "X="; HEX$(X&);
2580 Y& = Y& XOR M&: PRINT " Y="; HEX$(Y&)
2590 F& = ADDU(E&, Y&): PRINT "F="; HEX$(F&);
2600 G& = ADDU(E&, X&): PRINT " G="; HEX$(G&)
2610 F& = F& OR A&: PRINT "F="; HEX$(F&);
2620 G& = G& OR B&: PRINT " G="; HEX$(G&)
2630 F& = F& AND C&: PRINT "F="; HEX$(F&);
2640 G& = G& AND D&: PRINT " G="; HEX$(G&)
2650 X& = MUL1(X&, F&)
2660 Y& = MUL2A(Y&, G&)
2670 REM PRINT "SECONDS INSIDE MAIN="; (TIME - T0) / 100
2680 PRINT "X="; HEX$(X&); " Y="; HEX$(Y&)
2690 PRINT "Z= X XOR Y="; HEX$(X& XOR Y&)
END SUB

2720 SUB MAIN2 (M&)
2730 REM SHARED A&, B&, C&, D&, V&, X&, Y&, W&, TIME: REM LOCAL E&,F&,G&,T0
REM PRINT " MAIN2 begins M(or S,T)="; HEX$(M&);
REM PRINT " A="; HEX$(A&); " B="; HEX$(B&); " C="; HEX$(C&); " D="; HEX$(D&)
REM PRINT " V="; HEX$(V&); " W="; HEX$(W&); " X0="; HEX$(X0&); " Y0="; HEX$(Y0&)
2740 T0 = TIME
2750 V& = CYC(V&)
2760 E& = V& XOR W&
2770 X& = X& XOR M&
2780 Y& = Y& XOR M&
2790 F& = ADDU(E&, Y&)
2800 G& = ADDU(E&, X&)
2810 F& = F& OR A&
2820 G& = G& OR B&
2830 F& = F& AND C&
2840 G& = G& AND D&
2850 X& = MUL1(X&, F&)
2860 Y& = MUL2A(Y&, G&)
2870 REM PRINT " SECONDS INSIDE MAIN="; (TIME - T0) / 100
REM PRINT "MAIN2 ENDS ";
2880 PRINT "X="; HEX$(X&); " Y="; HEX$(Y&)
PRINT #1, "X="; HEX$(X&); " Y="; HEX$(Y&)
END SUB

1120 FUNCTION MENU1%
REM LOCAL N%
INPUT "PRESS RET FOR MENU", N%
1140 PRINT '"Message Authenticator Menu"
1150 PRINT "1 Test small functions (Tables 1,2)"
1160 PRINT "2 Test Prelude (Table 3)"
1170 PRINT "3 Test Main (Table 4)"
1180 PRINT "4 Test Prelude + Main + Coda (Table 5)"
1190 PRINT "5 Test repeated message blocks (Table 6)"
1200 PRINT "6 Quit"
1210 INPUT "Select by number ", N%
1220 IF (N% < 1) OR (N% > 6) THEN 1140
1230 MENU1 = N%
PRINT #1, " MENU="; N%
END FUNCTION

1310 FUNCTION MUL1& (X&, Y&)
1320 REM SHARED U&, L&, CAR&: REM LOCAL L1&
1330 CALL MUL32(X&, Y&)
REM PRINT "MUL1: U&="; HEX$(U&); " L&="; HEX$(L&)
1340 L1& = ADDU&(U&, L&)
REM PRINT "MUL1: S="; HEX$(L1&); " CAR&="; HEX$(CAR&)
1350 MUL1& = ADDU&(L1&, CAR&)
END FUNCTION

800 FUNCTION MUL16& (X&, Y&)
810 REM LOCAL L1&,L2&,H8&
811 H8& = &H10000 \ 2
812 REM PRINT "MUL16: X&="; HEX$(X&); " Y&="; HEX$(Y&);
820 IF (X& AND Y& AND H8&) = 0 THEN L1& = X& * Y&: GOTO 855
830 L1& = X& * (Y& AND &H7FFF)
840 L2& = (X& AND &H7FFF) * H8&
850 L1& = ADDU&(L1&, L2&)
851 L1& = ADDU&(L1&, &H40000000)
855 MUL16& = L1&
END FUNCTION

1370 FUNCTION MUL2& (X&, Y&)
1380 REM SHARED CAR&, L&, U&: REM LOCAL L1&
1390 CALL MUL32(X&, Y&)
1400 L1& = ADDU&(U&, U&)
1410 L1& = ADDU&(L1&, 2 * CAR&)
1420 L1& = ADDU&(L1&, L&)
1430 MUL2 = ADDU&(L1&, 2 * CAR&)
END FUNCTION

1450 FUNCTION MUL2A& (X&, Y&)
1460 REM SHARED CAR&, L&, U&: REM LOCAL L1&
REM PRINT "MUL2A"
1470 CALL MUL32(X&, Y&)
1480 L1& = ADDU&(U&, U&)
1490 L1& = ADDU&(L1&, L&)
1500 MUL2A = ADDU&(L1&, CAR& + CAR&)
END FUNCTION

880 SUB MUL32 (X&, Y&)
890 REM SHARED U&, L&, CAR&:
891 REM LOCAL XU&,XL&,YU&,YL&,P1&,P2&,H8&,H10&,HF&,H7F&,P1&,P2&
900 H10& = &H10000: H8& = H10& \ 2: HF& = H10& - 1: H7F& = &H7FFF0000
910 XU& = (X& AND H7F&) \ H10&
920 IF X& < 0 THEN XU& = XU& + H8&
930 XL& = X& AND HF&
940 YU& = (Y& AND H7F&) \ H10&
950 IF Y& < 0 THEN YU& = YU& + H8&
960 YL& = Y& AND HF&
970 L& = MUL16(XL&, YL&)
980 P1& = MUL16(XL&, YU&)
990 P2& = MUL16(XU&, YL&)
1000 P1& = ADDU(P1&, P2&)
1010 U& = (P1& AND H7F&) \ H10&
1020 IF P1& < 0 THEN U& = U& + H8&
1030 U& = U& + CAR& * H10&
1040 P1& = (P1& AND HF&) * H8&
1050 P1& = ADDU(P1&, P1&)
1060 L& = ADDU(L&, P1&)
1070 U& = U& + CAR&
1080 P1& = MUL16(XU&, YU&)
1090 U& = ADDU(U&, P1&)
1100 END SUB

1790 SUB PRELUDE (X&, Y&, TEST&)
1800 REM LOCAL P&,Q&,J1&,J12&,J22&,J14&,J24&,J16&,J26&,J18&,J28&
1810 REM LOCAL K1&,K12&,K22&,K14&,K24&,K15&,K25&,K17&,K27&,K19&,K29&
1820 REM LOCAL HD&,H4&,H5&,H6&,H7&,H8&,H9&
REM SHARED X0&, Y0&, V0&, W&, S&, T&, U&, L&, PAT&
PRINT "PRELUDE BEGINS, TEST="; TEST&
LX& = X&: LY& = Y&
PRINT "X="; HEX$(X&); " Y="; HEX$(Y&)
1830 CALL BYT(X&, Y&)
1840 J1& = U&: K1& = L&: P& = PAT&
1850 PRINT "U="; HEX$(U&); " L="; HEX$(L&); " PAT="; HEX$(PAT&); " J1="; HEX$(J1&)
1860 IF TEST& THEN J1& = LX&: K1& = LY&: INPUT "ENTER P ? ", P&
PRINT "P="; HEX$(P&)
PRINT #1, "P="; HEX$(P&)
1870 Q& = (1 + P&) * (1 + P&)
1880 J12& = MUL1(J1&, J1&)
1890 J22& = MUL2(J1&, J1&)
1900 J14& = MUL1(J12&, J12&)
1910 J24& = MUL2(J22&, J22&)
1920 J16& = MUL1(J12&, J14&)
1930 J26& = MUL2(J22&, J24&)
1940 J18& = MUL1(J12&, J16&)
1950 J28& = MUL2(J22&, J26&)
1960 H4& = J14& XOR J24&
1970 H6& = J16& XOR J26&
1980 H8& = J18& XOR J28&
1990 PRINT "H4="; HEX$(H4&)
2000 PRINT "H6="; HEX$(H6&)
2010 PRINT "H8="; HEX$(H8&)
2020 K12& = MUL1(K1&, K1&)
2030 K22& = MUL2(K1&, K1&)
2040 K14& = MUL1(K12&, K12&)
2050 K24& = MUL2(K22&, K22&)
2060 K15& = MUL1(K1&, K14&)
2070 K25& = MUL2(K1&, K24&)
2080 K17& = MUL1(K12&, K15&)
2090 K27& = MUL2(K22&, K25&)
2100 K19& = MUL1(K12&, K17&)
2110 K29& = MUL2(K22&, K27&)
2120 HD& = K15& XOR K25&
2130 H5& = MUL2(HD&, Q&)
2140 H7& = K17& XOR K27&
2150 H9& = K19& XOR K29&
2160 PRINT "HD=H'="; HEX$(HD&)
2170 PRINT "H5="; HEX$(H5&)
2180 PRINT "H7="; HEX$(H7&)
2190 PRINT "H9="; HEX$(H9&)
2200 CALL BYT(H4&, H5&)
2210 X0& = U&: Y0& = L&
2220 PRINT "X0="; HEX$(X0&); " Y0="; HEX$(Y0&); " PAT="; HEX$(PAT&)
2230 CALL BYT(H6&, H7&)
2240 V0& = U&: W& = L&
2250 PRINT "V0="; HEX$(V0&); " W="; HEX$(W&); " PAT="; HEX$(PAT&)
2260 CALL BYT(H8&, H9&)
2270 S& = U&: T& = L&
2280 PRINT "S="; HEX$(S&); " T="; HEX$(T&); " PAT="; HEX$(PAT&)
2290 PRINT "END OF PRELUDE"
END SUB

